﻿using System;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace VZ20X_SAMPLE
{
    class Program
    {

        static TcpClient tcp;

        static void Main(string[] args)
        {
            /*VZ20X IP address*/
            string VZ20X_IP = "192.168.1.1";
            /*VZ20X communication port number*/
            int port = 34596;

            /*Modbus command of function code 70 (start)*/
            string FC70Start = "01460001";
            /*Modbus command of function code 70 (stop)*/
            string FC70Stop = "01460002";

            /*Modbus command of function code 71*/
            string FC71 = "01470001";

            /*ModbusTCP transaction ID*/
            string TrsnId = "0000";
            /*ModbusTCP protocol ID*/
            string PrtlId = "0000";
            /*ModbusTCP data length*/
            string Length = "0004";
            /*Character tring of send message*/
            string send_mes;
            /*Character tring of recive message*/
            string recive_mes;
            /*status of recive message*/
			string sts;

            tcp = new TcpClient(VZ20X_IP, port);

            /*Create Modbus/TCP command of function code 70(start)*/
            send_mes = TrsnId + PrtlId + Length + FC70Start;
            /*Message send and recive*/
			recive_mes = SendMes(send_mes);

            /*Create Modbus/TCP command of function code 71*/
            send_mes = TrsnId + PrtlId + Length + FC71;
            /*Send and recive fuction code 71 1000 times*/
            for (int i = 0; i < 1000; i++)
            {
                /*Message send and recive*/
                recive_mes = SendMes(send_mes);
                /*Recived character string display */
                Console.WriteLine(recive_mes);
				/*Get status from recived character string*/
                sts = recive_mes.Substring(16,2);

                /*Branch by status*/
                /*02 : VZ20X data buffer overwritten*/
                if (sts == "02")
                {
                    /*Stop mesurement and restart*/
                    send_mes = TrsnId + PrtlId + Length + FC70Stop;
                    recive_mes = SendMes(send_mes);

                    send_mes = TrsnId + PrtlId + Length + FC70Start;
                    recive_mes = SendMes(send_mes);
                }
                /*01 : VZ20X data buffer is empty*/
                else if (sts == "01")
                {
                    //何もしない
                }
                /* 00 : Normal(data collection completed)*/
                else
                {
                    //If you need to store data, please put the process here
                }
            }

        }

        /*************************************
        * Send and recive Modbus/TCP command
        * argument 　　:string mes 
        * return value :string
        * ************************************/
        static string SendMes(string mes)
        {
            NetworkStream ns = tcp.GetStream();
            ns.ReadTimeout = 1000;
            ns.WriteTimeout = 1000;

			/*hex string to byte arry*/
            byte[] SendBytes = HexStringToByte(mes);
				
			/*send byte arry*/
            ns.Write(SendBytes, 0, SendBytes.Length);
            /*send hex string display*/
			Console.WriteLine(mes);
            
            System.IO.MemoryStream ms = new System.IO.MemoryStream();
            byte[] ResBytes = new byte[256];
            int resSize = 0;
            /*Recive response*/
			do
            {
                resSize = ns.Read(ResBytes, 0, ResBytes.Length);

                if (resSize == 0)
                {
                    Console.WriteLine("Sever disconnect");
                    break;
                }

                ms.Write(ResBytes, 0, resSize);

            } while (ns.DataAvailable);
            ms.Close();
			
			/*byte arry to hex string*/
            string rcv_ms = ByteToHexString(ms.ToArray());
            return rcv_ms;
        }

        /*************************************
        * hex string to byte array
        * argument 　　:string s
        * return value :byte arry
        * ************************************/
        static byte[] HexStringToByte(string s)
        {
            byte[] buffer = new byte[s.Length / 2];

            for (int i = 0; i < s.Length; i += 2)
            {
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            }
            return buffer;
        }

        /*************************************
        * byte array to hex string 
        * argument 　　:byte[] data
        * return value　:string
        * ************************************/
        static string ByteToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
            {
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            }
            return sb.ToString().ToUpper();
        }
    }
}