import socket
import struct
import codecs
import time

#VZ20X IP address
VZ20X_IP = '192.168.1.1'
#ModbusTCP port number
TARGET_PORT = 502 
#Communication buffer size
BUFFER_SIZE = 512

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect((VZ20X_IP, TARGET_PORT))
sock.settimeout(3.0)

#MBAP Header
transactionId = 512
protocolId = 0
len = 15
unitId = 0x01

#Make count value of UNIX Time(+9h) from PC time.
ut = (time.time() + (9 * 60* 60)) *1000
ut_int = int(ut)

#Make Modbus/TCP communication frame.
functionCode_control = 16
start_reg = 0x0000
reg_size = 0x0004
reg_byte = 0x08
req_write_time = struct.pack('>3H 2B 2H 1B 1Q', int(transactionId), int(protocolId), int(len), int(unitId), int(functionCode_control), int(start_reg), int(reg_size), int(reg_byte), ut_int)
#print(req_write_time)

try:
	print("Send modbus request ...")
	
	#Write time.
	print("Write time")
	sock.send(req_write_time)
	res = sock.recv(BUFFER_SIZE)
	print("TX: {0}".format(codecs.encode(req_write_time, 'hex_codec')))
	print("RX: {0}".format(codecs.encode(res, 'hex_codec')))
	
	time.sleep(1)
finally:
    sock.close()